/* your java script code here */
var rpcURI = '/remote/json-rpc';
var isWindows;
var cache;

var isInitialized = false;

function initGWAdmin(){
	remote = jQuery.JR(rpcURI);
	loadResources(types, resources, "GWAdmin");
	//loadResources(types, w_resources, "GWWizzard");
}

function startGWAdmin(){
//    var isAutoLogin = getCookieAsBoolean(autoLoginCookie);
//    setChecked("autoLogin", getCookieAsBoolean(autoLoginCookie));
    initialLoadModalDialog();
    updateText();

    var isInitialized = remote.XGWDeviceAdmin_isInitialized();
    if(isError(isInitialized)) return; // it isn't login loginPerformed will check initialization status
    
    if(isInitialized.result){
    
	    var x = remote.multi(
	    		'XGWMiscSettings_isWindows',
	    		'XGWDeviceAdmin_getSystemInfo',
	    		'XGWNavigation_getApplications'
	    )
		if(isError(x[0])) return; 
		isWindows = x[0].result;
		
	    if(isError(x[2])) return; 
		var systemInfo = x[1].result;
		switch (systemInfo.State) {
			//Init installation State - 1, Sign On To Miele State - 2, Sign On Appliance Status - 3, Factory Settings State - 5  
			case 1: //installation State 
				showInitialInstalationProgress(setFirstPage, systemInfo.OperRemainingTime);
				break;
			case 2: //Sign On To Miele State
				showSignOnToMieleProgress(setFirstPage, systemInfo.OperRemainingTime);
				break;
			case 3: //Sign On Appliance Status 
				showSignOnProgress(setFirstPage, systemInfo.OperRemainingTime);
				break;
			case 5: //Factory Settings State  
				showFactoryResetProgress(setFirstPage, systemInfo.OperRemainingTime);
				break;
		}
	
		var resp = getApplications(x[2]);
	    initApplications(resp);
	    setFirstPage();
	  
    }else{ //not initialized
      setEmptyPage();	
	  showWizzardWelcome(); 
	}  
}

function getApplications(resp) {
	if(resp == null) resp = remote.XGWNavigation_getApplications();
	if(resp.error){
		showLoginDialog();
	}else 
	   return resp.result;
}

function getSubApplications(id) {
	var resp = remote.XGWNavigation_getSubApplications(id);
	if(resp.error){
		showLoginDialog();
	}else 
	   return resp.result;
}

function initApplications(app_data) {
	cleanPage();
	for(var i in app_data){
		var app = app_data[i];
		var appLink = getAppLink(i);
		appLink.attr('id', app.ID);
		if (app.ID == "settings_id") {
			appLink.html(app.Name + " " + "<img src='/gwadmin/img/lang.gif' class='navCheckBoxImg' style='margin: 0px;'/>");
		} else {
			appLink.text(app.Name);
		}
		
		appLink.data('href', app.Link);
		appLink.addClass('menu');
		
		if(app.Link){ //set application link
			appLink.data('help', app.Help);
			
			if(app.Link.indexOf('http') == 0)  {
				appLink.attr('target', 'miele');
			} else {
				appLink.removeAttr('target');
			}	

			appLink.unbind('click').click(function(event) {
											selectLink($(this));
											var target = $(this).attr('target');
											if (target) {
												$(this).attr('href', $(this).data('href'));
											} else {
												cleanSubApp();
												setPage($(this));
											}});
		} else { //get application info
			appLink.unbind('click').click(initSubApplications);
		}
	}
}




function initSubApplications(){
	cleanSubApp();
	setSubApplications($(this).attr('id'));
	
	subAppLink = getSubAppLink(0); //$('#sublink0');
	if(subAppLink) subAppLink.click();
}

function setSubApplications(appId){
	selectLink($('#'+appId));
	
	var subApps = getSubApplications(appId);	 
	for(j in subApps){
		var subApp = subApps[j];
		var subAppLink = getSubAppLink(j); //$('#sublink' + j);

		if (subApp.ID == "localization_id") {
			subAppLink.html(subApp.Name + " " + "<img src='/gwadmin/img/lang.gif' class='navCheckBoxImg' style='margin: 0px;'/>");
		} else {
			subAppLink.text(subApp.Name);
		}

		subAppLink.data('href', subApp.Link);
		subAppLink.data('help', subApp.Help);
		
		subAppLink.unbind('click').click(function(){
			selectLink($(this));
			setPage($(this));
		});
	}
}

function setPage(link) {
	if (link) {
			lastLink = link;
			var container = $('iframe#container');
			$('#help_title').data('help', link.data('help'));
			container.attr('src', link.data('href'));
		}else {
			setEmptyPage();
		}
}

function setEmptyPage(){
	var container = $('iframe#container');
	container.attr('src', 'empty.html');
	$('#wizzardFrame').hide();
	$('#help_title').removeData();
}

function setFirstPage(){
	//var appLink = $('#link0');
	var appLink = getAppLink(0);
	if(appLink){
	   appLink.click();
	}
}


function setLastPage(){
	if(lastLink){
		lastLink.click();
	}
}



function cleanSubApp(){
    $('.submenu').text('').removeData();
}


function cleanPage(all){
	cleanSubApp();
    $('.menu').text('').removeData().removeAttr('id');
    $('.menu').removeData();
    $('.menu').removeAttr('id');
    if(all){
    	setEmptyPage();
    }
}

function helpPerformed() {
	var newWidth = 850;
	var newHeight = 600;
	var link = $("#help_title").data('help');
  var leftVal= (screen.width - newWidth) / 2;
  var topVal = (screen.height - newHeight) / 2;

  var fullAddress = document.URL;
  var i = fullAddress.indexOf('/', 8);
    fullAddress = fullAddress.substring(0, i);
    fullAddress = fullAddress + link;
	window.open(fullAddress, "Help", "width=" + newWidth + "px, height=" + newHeight + "px, left=" + leftVal+", top=" + topVal + ", fullscreen=no, scrollbars=yes, resizable=yes");	
}

function getAppLink(index){
	var pos = parseInt(index) + 1;
	return $('#appTable tr td:nth-child('+pos+') a');
}

function getSubAppLink(index){
	var pos = parseInt(index) + 1;
	return $('#subApplicationTable tr td:nth-child('+pos+') a');
}


function selectLink(jqObj){
	if(jqObj.hasClass('menu')){
	  $('a.menu').removeClass('selected');
	}else{
	  $('a.submenu').removeClass('selected');
	}
	jqObj.addClass('selected');
}
