var lastCUType, lastCUId;


function initInfoServicePage(){
	remote = top.remote;
	loadResources(types, resources, 'InfoService');
	
}	

function startInfoServicePage(){
	$('#isInfo').html(
			'<p>'+getRes('infoservice.help1') +
			'<p>'+getRes('infoservice.help2') +
			'<p>'+getRes('infoservice.help3'));
	
	var x = remote.multi(
			'XGWInfoService_isActive',
			'XGWInfoService_getDeviceList'
			);
	updateText();

//	var x = remote.XGWInfoService_getDeviceList();
	if(isError(x[0])) return;
	var isActive = x[0].result;
	if(isActive){
		check($('#isActiveCheck'), 'checked');
		if(isError(x[1])) return;
		var devList = x[1].result
		if(devList.length > 0){
			loadDevRef(devList);
			setEnable($('#infoservice_register_devices_button'), true);
		}else{
			$('#infoservice_appinfo_device_test_report').hide();
			setEnable($('#infoservice_register_devices_button'), false);
		}
	}else{
		clean();
	}
	$('#content').show();
}

function activateIS(checkBox){
	if(isChecked(checkBox)){
		top.showConfirmationDialog( getRes('infoservice.title'), 
								getRes('infoservice.register.confirmation.message'),
								registerDevices
								);
		show();
	}else{
		remote.XGWInfoService_deactivate();
		clean();
	}
}

function loadDevRef(devRef){
	var trs = listAsDevRef(devRef);
	if(trs){
		$('#content').show();
		$('#appRef').html(trs);
		$('#appRef tr:first a').click();
		$('#faults').show();
		var c = $('#appliances').height();
		var y = $('#faults').height();
		var z = $('#isInfo').height();
		if(c < y) c = y;
		if(c < z) c = z;
		$('#appDiv').height(c);
		$('#faults').height(c);
	}	
}

function listAsDevRef(list) {
	if (!list || list.length == 0) return '';
	var h = '<fieldset id="deviceList" style="height:100%;">'+
				'<legend >' + getRes('ehs.label.device.list') + '</legend>'+
				'<div id="appDiv">' +
				'<table  style="margin:0;padding: 0 0 3px 0;" id="appliances" valign="top" border="0" cellpadding="0" cellspacing="0">'; 
	for(var i in list) {
		var cuType = list[i].CUType;
		var cuId = list[i].CUId;
		var devName = list[i].DeviceName;
		var fname = list[i].FriendlyName;
		var name = devName;
		if (fname != '') {
			name = devName + ' - ' +fname;  
		}
		
		var isSupported = list[i].IsSupported;
		if(isSupported){
			var checkAttr = list[i].InfoServiceReg ? 'checked="checked"' : ''; 
			h += '<tr width="25px" ><td valign="top"><input type="checkbox" value="true" '+checkAttr+'  onclick="setActiveDevice($(this), \''+cuType+'\', \''+cuId +'\');"></td>' + 
							'<td align="left" valign="top"><a class="arrow-link"  onclick="selectApp($(this), \''+cuType+'\', \''+cuId +'\', \''+devName +'\');">'
							+ name + '</a>' 
				'</td></tr>';
		
		}else{ // not supported
			h += '<tr  width="25px"><td><input value="false" type="checkbox" disabled="true" ></td>' + 
				'<td align="left" ><span class="arrow-link-disabled" >'	+ name + getRes('infoservice.not.supported')+ '</span>' 
			'</td></tr>';
				
		}	
	}
	h += '</table></div></fieldset>';
									
	return h;
}

function devPropInfoAsTr(list) {
	if (!list ) return '';
	var h = ''; 
	for(var i in list) {
		h += '<tr><td  >'+ list[i].Name + '</td>'+
				 '<td  >' +  list[i].Value + '</td></tr>';
	}
									
	return h;
}


function  selectApp(link, cuType, cuId, devName){
	var fabr = remote.XGWInfoService_getFabricationNumber(cuType, cuId);
	var x = remote.XGWInfoService_getDeviceInfo(cuType, cuId);
	if(isError(x)) return;
	lastCUType = cuType; 
	lastCUId = cuId;
	//$('#appPropsTable').html(devPropInfoAsTr(x.result.DeviceInfo));
	
	$('#infoservice_protocoldata_last_transmission_label').text(getRes('infoservice.protocoldata.last.transmission.label') +' - '+devName);	
	var faults = x.result.TransmittedFaults;
	var faultMsg = '<div style="height:20px">'+getRes('infoservice.appinfo.device.fabrication')+': ' + fabr.result +'</div>';
	if(faults != null){
		faultMsg = faultMsg + '<ul style="margin:0px; padding:0px;">'+listAsOptions(faults)+'</ul>';
	}else{
		faultMsg = faultMsg + getRes('infoservice.protocoldata.no.transmissions');
	}	

	$('#appProps').show();
	$('#faultMsg').html(faultMsg);
	$('#infoservice_appinfo_device_test_report').show();
	
	var appInfo = x.result;
	$('a.arrow-link').removeClass('selected');
	link.addClass('selected');
}

function setActiveDevice(link, cuType, cuId){
	var x;
	if(isChecked(link)){
		x = remote.XGWInfoService_activateDevice(cuType, cuId);
	}else{
		x = remote.XGWInfoService_deactivateDevice(cuType, cuId);
	}
	if(isError(x)) return;
}

function show(){
	var x = remote.XGWInfoService_activate();
	if(isError(x)) return;
	var list = loadDevRef(x.result);
	$('#registrationFieldset').show();
	if(list && list.length > 0){
		$('#appProps').show();
	}	
} 

function sendEMail(){
	if(lastCUType != null && lastCUId != null){
		remote.XGWInfoService_sendEMail(lastCUType, lastCUId);
	}
}

function registerDevices(){
	var x = remote.XGWInfoService_getRegistrationURL();
	if(isError(x)) return;
	window.open(x.result);
}


function clean(){
	check($('#isActiveCheck'), false);
	$('#appRef').html('');
	$('#appProps').hide();
	$('#infoservice_appinfo_device_test_report').hide();
	$('#registrationFieldset').hide();
}