function initNetworkPage(){    
	//init RPC
	//rpcURI = '/remote/json-rpc';
	//remote = jQuery.JR(rpcURI);
	remote = top.remote;
	var x = remote.XGWNetwork_getNetworkProperties();
	if(!isError(x, 'XGWNetwork_getNetworkProperties')) networkProperties = x.result;
    loadResources(types, resources, "Network");
}    


function startNetworkPage(){
 	updateText();
	if(!top.isWindows && networkProperties) {
		initData(); 
		$('#pageContent').show();		 
	} else {
		$('#network_missing_service').show();		 
	}
}

function initData(){    
	$('#friendlyName').val(networkProperties.FriendlyName);
    $('#hostName').val(networkProperties.HostName);
  
    fillIPValue('ipAddress_', networkProperties.IPAddress);
    fillIPValue('subNetMask_', networkProperties.SubnetMask);
    fillIPValue('defaultGateway_', networkProperties.DefaultGateway);
    
    if(networkProperties.DNSEntries){
        fillIPValue('dns1_', networkProperties.DNSEntries[0]);
        fillIPValue('dns2_', networkProperties.DNSEntries[1]);
      }  

    var dhcpCheck = $('#dhcpEnabledCheck');
    dhcpCheck.change(function(e){
    	var isCheck = isChecked($(this));
		if (isCheck) {
	        $('.dhcp').attr('disabled', true);
		} else {
	        $('.dhcp').prop('disabled', null);
		}

        $(this).attr('checked', isCheck);              
    }); 
    $('.dhcp').keydown(function(event) {
				    // Allow only backspace and delete
				    if ( event.keyCode == 46 || event.keyCode == 8 ) {
				        // let it happen, don't do anything
				    }
				    else {
				        // Ensure that it is a number and stop the keypress
				        if (event.keyCode < 48 || event.keyCode > 57 ) {
				            event.preventDefault(); 
				        }   
				    }
				});
    //dhcpCheck.attr('checked', networkProperties.DHCPEnabled);
    check(dhcpCheck, networkProperties.DHCPEnabled);
    dhcpCheck.change();
}

function update(){
	top.showConfirmationDialog(getResource(resourceMap,'network.page.title'), getResource(resourceMap, 'network.confirm.message'), setNetworkProperties);
}

function setNetworkProperties(){
  if(checkFriendlyName()){
	  if(checkHostName()){
		  if(isChecked($('#dhcpEnabledCheck'))){
			 
			  var x = remote.XGWNetwork_setNetworkProperties(true, 
					 								$('#friendlyName').val(),
					 								$('#hostName').val(),
					 								null, null, null, null);
			  isError(x);
			  
		  }else{
			 if(checkIPValue('ipAddress_')){
				if(checkIPValue('subNetMask_')){ 
					if(checkIPValue('defaultGateway_')){
						if(checkIPValue('dns1_')) {
							var x = remote.XGWNetwork_setNetworkProperties(false, 
						     								$('#friendlyName').val(),
															$('#hostName').val(),
															computeIPValue('ipAddress_'),
															computeIPValue('subNetMask_'),
															computeIPValue('defaultGateway_'),
															isEmptyIPValue('dns2_') ? [computeIPValue('dns1_')] : 
																					  [computeIPValue('dns1_'), computeIPValue('dns2_')]);
							isError(x);
						
						}else top.showInfoDialog(getResource(resourceMap,'network.page.title'), getResource(resourceMap, 'network.invalid.dns.ip'), 'error'); 
					}else top.showInfoDialog(getResource(resourceMap,'network.page.title'), getResource(resourceMap, 'network.invalid.dg.ip'), 'error');
				}else top.showInfoDialog(getResource(resourceMap,'network.page.title'), getResource(resourceMap, 'network.invalid.mask.ip'), 'error');	
			 }else top.showInfoDialog(getResource(resourceMap,'network.page.title'), getResource(resourceMap, 'network.invalid.ip'), 'error'); 
		  }
	  }else top.showInfoDialog(getResource(resourceMap,'network.page.title'), getResource(resourceMap, 'network.invalid.host.name'), 'error');	  
  }else top.showInfoDialog(getResource(resourceMap,'network.page.title'), getResource(resourceMap, 'network.invalid.friendly.name'), 'error'); 
}



function checkFriendlyName() {
  var name = document.getElementById("friendlyName").value; 	
  if (name == null || name.length == 0 || name.length > 64) {
    return false; 
  } else {
    return true;
  } 	
}

function checkHostName() {
  var name = document.getElementById("hostName").value; 	
  if (name == null || name.length == 0) {
    return false; 
  }
  for (i = 0; i < name.length; i++) {
    ch = name.charAt(i);
    if (!((ch >= 'a' && ch <= 'z') ||
         (ch >= 'A' && ch <= 'Z') ||
         (ch >= '0' && ch <= '9') ||
         ch == '0' || ch == '-')) {
      	return false;
      }
    }
    return true; 
}

function checkIPValue(prefixId){
  isMask = (prefixId == 'subNetMask_');	
  for(i = 0; i < 4; i++) {
    value = document.getElementById(prefixId + i).value;
	if(isNaN(value) || value.length == 0)
	  return false;
	num = Number(document.getElementById(prefixId + i).value);
	if(i == 0) {
	  if(num > 255 ||num < (isMask ? 0 : 1))
	  return false; 	
	} else {
	 if(num > 255 ||num < 0)
	  return false;   
	}
  }
  return true; 
}

function computeIPValue(prefix) {
	arr = new Array();  	
	for(k = 0; k < 4; k++) {
	  arr[k] = parseInt(document.getElementById(prefix + k ).value);
	}
	return arr;  
}


function fillIPValue(id, array) {
  if(array && array.length > 0) {
    for(x in array) {
      document.getElementById(id + x).value= array[x]; 	
    }
  } 
}

function isEmptyIPValue(prefixId) {
  var isEmpty = true; 	
  for(i = 0; i < 4; i++) {
    isEmpty &= document.getElementById(prefixId + i).value.length == 0 ;
  }
  return isEmpty; 
}

