var jqWCmpId = "#w_";
var aWPeriods;
var isWChanged = false;
var wLastSelIdx = 0;
var isWLoaded = false;

var jqNotWCmpId = "#nw_";
var aNotWPeriods; 
var isNotWChanged = false;
var notWLastSelIdx = 0;
var isNotWLoaded = false;


function initSgCalendarPage(){
	remote = top.remote;
	loadResources(types, resources, 'SG_Calendar');
	loadData();
}	

function startSgCalendarPage(){
	if(!isWLoaded) loadData(jqWCmpId);
	if(!isNotWLoaded) loadData(jqNotWCmpId);
	setUp(jqWCmpId);
	setUp(jqNotWCmpId);
	$('#content').show();
}

function setUp(jqCmpId){
	updateState(jqCmpId);
	$(jqCmpId + 'begin_hours').html(getHOptions(0));
	$(jqCmpId + 'begin_minutes').html(getMOptions(0));
	$(jqCmpId + 'end_hours').html(getHOptions(0));
	$(jqCmpId + 'end_minutes').html(getMOptions(0));
	showPeriods(jqCmpId, false);
	updateText(resourceMap, jqCmpId);
}

function setPeriodColor(sel){
	var tariff = sel.val();
	var color = getColor(tariff);
	sel.css('background', color);
}

function showPeriods(jqCmpId, reload){
	if (reload) {
		loadData();
	}

	var aPeriods = getAPeriod(jqCmpId);
	
	if (aPeriods) {
		var p, width, height, color, s='';
		for(i = 0; i < aPeriods.length; i++){
			p = aPeriods[i];
			color = getColor(p.Tariff);
			height = getEditorHeight(p.Tariff);
			width = getPixWidth(p.EndTime - p.BeginTime) - 2;
			s += '<td  valign="bottom" height="72px" width="' + width + 'px ">' +
					'<div onclick="selectPeriod(\''+jqCmpId + '\', '+i+'); "'    
						+' class="borderRound aPeriod" style="background-color:'+ color +'; height:' + height + 'px;"></div></td>'	
		}
		$(jqCmpId + 'tableView tr').html(s);
		selectPeriod(jqCmpId, getLastSelIdx(jqCmpId));
	}
}

//TODO optimise calls
function loadData(jqCmpId){
	if(jqCmpId == null){
		x = remote.multi(
							['XGWSmartGrid_getManualModeTariffPeriods', 0],
							['XGWSmartGrid_getManualModeTariffPeriods', 1]
					);
		if(isError(x[0])) return;
		aWPeriods = x[0].result;
		isWLoaded = true;
		if(isError(x[1])) return;
		aNotWPeriods = x[1].result;
		isNotWLoaded = true;

	}else{
    	if(jqCmpId == jqWCmpId){
			x = remote.XGWSmartGrid_getManualModeTariffPeriods(0);
			if(isError(x)) return;
			aWPeriods = x.result;
			isWLoaded = true;
		}	
		if(jqCmpId == null || jqCmpId == jqNotWCmpId){
			x = remote.XGWSmartGrid_getManualModeTariffPeriods(1);
			if(isError(x)) return;
			aNotWPeriods = x.result;
			isNotWLoaded = true;
		}
	}

	
}

function selectPeriod(jqCmpId, idx){
	updateState(jqCmpId);
	var x = $(jqCmpId +'tableView' + ' .aPeriod');
	x.css('opacity', '1');
	x.css('filter', 'alpha(opacity=100)');
	x.css('background-image', 'none');

	if(idx >= 0){
		x = $(jqCmpId + 'tableView td:nth-child('+(idx + 1)+') div');
		x.css('opacity', '0.5');
		x.css('filter', 'alpha(opacity=50)');
		x.css('background-image', 'url(img/selection.png)');
		x.css('background-repeat', 'repeat');

		var aPeriods = getAPeriod(jqCmpId);
		var p = aPeriods[idx];
		var timeObj = getTime(p.BeginTime);
		setBeginTime(jqCmpId, timeObj);
		var endTimeObj = getTime(p.EndTime);
		setEndTime(jqCmpId, endTimeObj, timeObj);
		$(jqCmpId + 'selectPeriod').val(p.Tariff).change();
	}
	setChanged(jqCmpId, false);
	setLastSelIdx(jqCmpId, idx);
}

function updateState(jqCmpId){
	if(isChanged(jqCmpId)){
		$(jqCmpId +'smart_grid_add_label').show();
		$(jqCmpId +'smart_grid_set_label').hide();
		$(jqCmpId +'smart_grid_remove_label').attr('disabled', true);
		
	}else{
		$(jqCmpId +'smart_grid_add_label').hide();
		$(jqCmpId +'smart_grid_set_label').show();
		
		var aPeriods = getAPeriod(jqCmpId);
		if(aPeriods && aPeriods.length > 1){
			$(jqCmpId +'smart_grid_remove_label').prop('disabled', null);
		}else{
			$(jqCmpId +'smart_grid_remove_label').attr('disabled', true);
		}	
	}	
} 

function addPeriod(jqCmpId){
	var startTime = getMin(getBeginTime(jqCmpId));
	var endTime = getMin(getEndTime(jqCmpId));
	var tariff = parseInt($(jqCmpId + 'selectPeriod').val());
	var x = remote.XGWSmartGrid_addManualModeTariffPeriod(startTime, endTime, getTypeOfDays(jqCmpId), tariff);
	if(isError(x)) return;
	updatePeriods(jqCmpId, x.result);
	setLastSelIdx(jqCmpId, 0);
	showPeriods(jqCmpId, true);
}

function setTariff(jqCmpId){
	var startTime = getMin(getBeginTime(jqCmpId));
	var tariff = parseInt($(jqCmpId + 'selectPeriod').val());
	var x = remote.XGWSmartGrid_setManualModeTariffPlan(startTime, getTypeOfDays(jqCmpId), tariff);
	if(isError(x)) return;
	updatePeriods(jqCmpId, x.result);
	showPeriods(jqCmpId, false);
}

function removePeriod(jqCmpId){
	var startTime = getMin(getBeginTime(jqCmpId));
	var x = remote.XGWSmartGrid_removeManualModeTariffPeriod(startTime, getTypeOfDays(jqCmpId));
	if(isError(x)) return;
	updatePeriods(jqCmpId, x.result);
	setLastSelIdx(jqCmpId, 0);
	showPeriods(jqCmpId, true);
}

/*Return begin time as Time object*/
function getBeginTime(jqCmpId){
	return {h: $(jqCmpId + 'begin_hours').val(), m: $(jqCmpId + 'begin_minutes').val()};
}

/*Set begin time represented as time object*/
function setBeginTime(jqCmpId, timeObj){
	$(jqCmpId + 'begin_hours').val(timeObj.h);
	$(jqCmpId + 'begin_minutes').val(timeObj.m);
}

/*Return end time as Time object*/
function getEndTime(jqCmpId){
	return {h: $(jqCmpId + 'end_hours').val(), m: $(jqCmpId + 'end_minutes').val()};
}

/*Set endtime represented as Time object*/
function setEndTime(jqCmpId, timeObj, startTimeObj){
	var endStartTime = startTimeObj.h;
	if (startTimeObj.m == 45) {
		endStartTime++;
	}
	$(jqCmpId + 'end_hours').html(getHOptions(endStartTime));
	$(jqCmpId + 'end_hours').val(timeObj.h);
	var startMinues = 0;
	if (timeObj.h == startTimeObj.h) {
		startMinues = startTimeObj.m + 15;
		if (startMinues == 60) {
			startMinues = 0;
		}
	}
	$(jqCmpId + 'end_minutes').html(getMOptions(startMinues, timeObj.h == 24));
	$(jqCmpId + 'end_minutes').val(timeObj.m);
}

function changePeriod(jqCmpId, updateEnd){
	setChanged(jqCmpId, true);
	selectPeriod(jqCmpId, -1);
	
	if(updateEnd){
		lastEndTime = getEndTime(jqCmpId);
		var eTime = getMin(getEndTime(jqCmpId));
		var bTime = getMin(getBeginTime(jqCmpId));
		var delta = eTime - bTime; 
		if(delta > 60){
			bTime +=15;
			var oTime = getTime(bTime);
			var x = $(jqCmpId + 'end_hours'); 
			x.html(getHOptions(oTime.h));
			x.val(lastEndTime.h);
			x = $(jqCmpId + 'end_minutes'); 
			x.html(getMOptions(0, lastEndTime.h == 24));
			x.val(lastEndTime.m);
		
		}else if(delta < 0){
			bTime +=15;
			var oTime = getTime(bTime);
			$(jqCmpId + 'end_hours').html(getHOptions(oTime.h));
			$(jqCmpId + 'end_minutes').html(getMOptions(oTime.m, oTime.h == 24));
			
		}else{
			bTime +=15;
			var oTime = getTime(bTime);
			$(jqCmpId + 'end_hours').html(getHOptions(oTime.h));
			$(jqCmpId + 'end_minutes').html(getMOptions(oTime.m, (oTime.h == 24)));
			$(jqCmpId + 'end_minutes').val(lastEndTime.m);
		}
	}

}

function setChanged(jqCmpId, value){
	if(jqCmpId == jqWCmpId){
		isWChanged = value;
	} else if(jqCmpId == jqNotWCmpId){
		isNotWChanged = value;
	}
}

function isChanged(jqCmpId){
	return jqCmpId == jqWCmpId ? isWChanged : isNotWChanged;
}

function setLastSelIdx(jqCmpId, value){
	if(jqCmpId == jqWCmpId){
		wLastSelIdx = value;
	} else if(jqCmpId == jqNotWCmpId){
	    notWLastSelIdx = value;
	}
}

function getLastSelIdx(jqCmpId){
	return jqCmpId == jqWCmpId ? wLastSelIdx : 
								 jqCmpId == jqNotWCmpId ? notWLastSelIdx : -1;
}

function getTypeOfDays(jqCmpId){
	return jqCmpId == jqWCmpId ? 0 : 1; 
}

function getAPeriod(jqCmpId){
	return jqCmpId == jqWCmpId ? aWPeriods : aNotWPeriods; 
}

function updatePeriods(jqCmpId, arr){
	if(jqCmpId == jqWCmpId){
		aWPeriods = arr;
	} else if(jqCmpId == jqNotWCmpId){
		aNotWPeriods = arr;
	}
}

//////utility methods/////////

/*Round minutes to 15 minutes period*/
function roundMin(min){
	var m = min;
	var x = m % 15; 
	if(x != 0) m -= x;
	return m;
}
/*Convert minutes to Time object*/
function getTime(minutes){
	if(!(minutes != null)) return null;
	
	var hour = Math.round(minutes / 60 - 0.5);
	var min = Math.round(minutes % 60);
	return {h: hour, m: min};
}

/*Convert Time object to minutes presentation*/
function getMin(obj){
	if(!(obj.h != null && obj.m != null)) return -1;
	return parseInt(obj.h) * 60 + roundMin(parseInt(obj.m));
}

/*Return number of pixels corresponding to specified time period*/
function getPixWidth(min){
	return roundMin(min) / 15 * 9;
}

function getHOptions(startIdx){
	var opt = '';
	for( i = startIdx; i < 25; i++){
		opt += '<option>'+i+'</option>';
	}
	return opt;
}

function getMOptions(startIdx, is24h){
	if (is24h) {
		return '<option>0</option>';
	}
	var opt = '';
	for( i = startIdx; i <= 45; i+=15){
		opt += '<option>'+i+'</option>';
	}
	return opt;
}


