var isSgActive, tariffs, curTariff, aPeriods; 
var isChanged = false;
var lastSelIdx = 0;
var isLoaded = false;

function initSgGeneralPage(){
	remote = top.remote;
	loadResources(types, resources, 'SG_General');
	
	var x = remote.multi(
							'XGWSmartGrid_isSmartGridActive',
							'XGWSmartGrid_getAvailableTariffPlans',
							'XGWSmartGrid_getCurrentTariffPlan',
							'XGWSmartGrid_getActivityPeriods'
						);
	if(isError(x[0])) return;
	isSgActive = x[0].result;
	if(isError(x[1])) return;
	tariffs = x[1].result;
	if(isError(x[2])) return;
	curTariff = x[2].result;

	if (isSgActive) {		
		if(isError(x[3])) return;
		aPeriods = x[3].result;
	}
	
	isLoaded = true;
}	

function startSgGeneralPage(){
	if(!isLoaded) initSgGeneralPage();
	updateState();

	$('#begin_hours').html(getHOptions(0));
	$('#begin_minutes').html(getMOptions(0));
	$('#end_hours').html(getHOptions(0));
	$('#end_minutes').html(getMOptions(0));

	check($('#isActiveCheck'), isSgActive);
	activateSG(false);
	
	$('#tariffSelect').html(keyValueListAsOptions(tariffs));
	$('#tariffSelect').val(curTariff);
    
	showPeriods(false);
	updateText();
	
	$('#content').show();
}

function setPeriodColor(){
	var sel = $('#selectPeriod');
	var color = sel.val() == -1? '#00AAFF' : '#C0C0C0';
	sel.css('background', color);
}

function activateSG(update){
	isSgActive = isChecked($('#isActiveCheck')); 
	if(update) {
		remote.XGWSmartGrid_setSmartGridActive(isSgActive);
		top.cleanSubApp();
		top.setSubApplications('smart_grid_id');

	}
	var e = $('#editor');
    var c = $('#tarrifCombo');
	if(isSgActive){
		showPeriods(update);
		e.show();
        c.show();
	}else {
		e.hide();
        c.hide();
	}
}

function changeTariff(){
	remote.XGWSmartGrid_setCurrentTariffPlan($('#tariffSelect').val());
	top.cleanSubApp();
	top.setSubApplications('smart_grid_id');
}

function showPeriods(reload){
	if (isSgActive  && reload) {		
		x = remote.XGWSmartGrid_getActivityPeriods();
		if(isError(x)) return;
		aPeriods = x.result;
	}

	if (aPeriods) {
		var p, width, color, s='';
		for(i = 0; i < aPeriods.length; i++){
			p = aPeriods[i];
			color = p.Tariff == -1 ? '#00AAFF' : '#C0C0C0';
			width = getPixWidth(p.EndTime - p.BeginTime) - 2;
			s += '<td  valign="bottom" height="72px" width="' + width + 'px ">' +
					'<div onclick="selectActPeriod('+i+');" ' 
						+' class="borderRound aPeriod" style="background-color:'+ color +';"></div></td>'	
		}
		$('#tableView tr').html(s);
		selectActPeriod(lastSelIdx);
	}
}

function selectActPeriod(idx){
	updateState();
	//$('.aPeriod').css('margin-bottom', '0px');
	var x = $('div.aPeriod');
	x.css('opacity', '1');
	x.css('filter', 'alpha(opacity=100)');
	x.css('background-image', 'none');

	if(idx >= 0){
		//var cmp = $('#tableView td:nth-child('+(idx + 1)+') div');
		//cmp.css('margin-bottom', '10px');
		x = $('#tableView td:nth-child('+(idx + 1)+') div');
		x.css('opacity', '0.5');
		x.css('filter', 'alpha(opacity=50)');
		x.css('background-image', 'url(img/selection.png)');
		x.css('background-repeat', 'repeat');

		var p = aPeriods[idx];
		var timeObj = getTime(p.BeginTime);
		setBeginTime(timeObj);
		var endTimeObj = getTime(p.EndTime);
		setEndTime(endTimeObj, timeObj);
		$('#selectPeriod').val(p.Tariff).change();
	}
	isChanged = false;
	lastSelIdx = idx;
}

function updateState(){
	if(isChanged){
		$('#smart_grid_add_label').show();
		$('#smart_grid_set_label').hide();
		$('#smart_grid_remove_label').attr('disabled', true);
		
	}else{
		$('#smart_grid_add_label').hide();
		$('#smart_grid_set_label').show();
		
		if(aPeriods && aPeriods.length > 1){
			$('#smart_grid_remove_label').prop('disabled', null);
		}else{
			$('#smart_grid_remove_label').attr('disabled', true);
		}	
	}	
} 

function addPeriod(){
	var startTime = getMin(getBeginTime());
	var endTime = getMin(getEndTime());
	var x = remote.XGWSmartGrid_addActivityPeriod(startTime, endTime, ($('#selectPeriod').val() == -1));
	if(isError(x)) return;
	aPeriods = x.result;
	lastSelIdx = 0;
	showPeriods(true);
}

function setPeriod(){
	var startTime = getMin(getBeginTime());
	var x = remote.XGWSmartGrid_setActivityPeriod(startTime, ($('#selectPeriod').val() == -1));
	if(isError(x)) return;
	aPeriods = x.result;
	showPeriods(false);
}

function removePeriod(){
	var startTime = getMin(getBeginTime());
	var x = remote.XGWSmartGrid_removeActivityPeriod(startTime);
	if(isError(x)) return;
	aPeriods = x.result;
	lastSelIdx = 0;
	showPeriods(true);
}

/*Return begin time as Time object*/
function getBeginTime(){
	return {h: $('#begin_hours').val(), m: $('#begin_minutes').val()};
}

/*Set begin time represented as time object*/
function setBeginTime(timeObj){
	$('#begin_hours').val(timeObj.h);
	$('#begin_minutes').val(timeObj.m);
}

/*Return end time as Time object*/
function getEndTime(){
	return {h: $('#end_hours').val(), m: $('#end_minutes').val()};
}

/*Set endtime represented as Time object*/
function setEndTime(timeObj, startTimeObj){
	var endStartTime = startTimeObj.h;
	if (startTimeObj.m == 45) {
		endStartTime++;
	}
	$('#end_hours').html(getHOptions(endStartTime));
	$('#end_hours').val(timeObj.h);
	var startMinues = 0;
	if (timeObj.h == startTimeObj.h) {
		startMinues = startTimeObj.m + 15;
		if (startMinues == 60) {
			startMinues = 0;
		}
	}
	$('#end_minutes').html(getMOptions(startMinues, timeObj.h == 24));
	$('#end_minutes').val(timeObj.m);
}

function changePeriod(updateEnd){
	isChanged = true;
	selectActPeriod(-1);
	if(updateEnd){
		lastEndTime = getEndTime();
		var eTime = getMin(getEndTime());
		var bTime = getMin(getBeginTime());
		var delta = eTime - bTime; 
		if(delta > 60){
			bTime +=15;
			var oTime = getTime(bTime);
			var x = $('#end_hours'); 
			x.html(getHOptions(oTime.h));
			x.val(lastEndTime.h);
			x = $('#end_minutes'); 
			x.html(getMOptions(0, lastEndTime.h == 24));
			x.val(lastEndTime.m);
		
		}else if(delta < 0){
			bTime +=15;
			var oTime = getTime(bTime);
			$('#end_hours').html(getHOptions(oTime.h));
			$('#end_minutes').html(getMOptions(oTime.m, oTime.h == 24));
			
		}else{
			bTime +=15;
			var oTime = getTime(bTime);
			$('#end_hours').html(getHOptions(oTime.h));
			$('#end_minutes').html(getMOptions(oTime.m, (oTime.h == 24)));
			$('#end_minutes').val(lastEndTime.m);
		}
	}
}

//////utility methods/////////

/*Round minutes to 15 minutes period*/
function roundMin(min){
	var m = min;
	var x = m % 15; 
	if(x != 0) m -= x;
	return m;
}
/*Convert minutes to Time object*/
function getTime(minutes){
	if(!(minutes != null)) return null;
	
	var hour = Math.round(minutes / 60 - 0.5);
	var min = Math.round(minutes % 60);
	return {h: hour, m: min};
}

/*Convert Time object to minutes presentation*/
function getMin(obj){
	if(!(obj.h != null && obj.m != null)) return -1;
	return parseInt(obj.h) * 60 + roundMin(parseInt(obj.m));
}

/*Return number of pixels corresponding to specified time period*/
function getPixWidth(min){
	return roundMin(min) / 15 * 9;
}


function getHOptions(startIdx){
	var opt = '';
	for( i = startIdx; i < 25; i++){
		opt += '<option>'+i+'</option>';
	}
	return opt;
}

function getMOptions(startIdx, is24h){
	if (is24h) {
		return '<option>0</option>';
	}
	var opt = '';
	for( i = startIdx; i <= 45; i+=15){
		opt += '<option>'+i+'</option>';
	}
	return opt;
}