function initSgStatusPage(){
	remote = top.remote;
    loadResources(types, resources, 'SG_Status');
}



function startSgStatusPage(){
    updateText();

	var x = remote.XGWSmartGrid_isManualMode();
	if(isError(x)) return;
	var isManual = x.result;
	
	var tariff1, tariff2;  
	if(isManual){
		tariff1 = ['XGWSmartGrid_getManualModeTariffPeriods',0];
		tariff2 = ['XGWSmartGrid_getManualModeTariffPeriods',1];
	}else{
		tariff1 = ['XGWSmartGrid_getCustomModeTariffPeriods',2];
		tariff2 = ['XGWSmartGrid_getCustomModeTariffPeriods',4];
	}
	
	x = remote.multi(
						'XGWSmartGrid_getActivityPeriods',
						tariff1, 
						tariff2,
						'XGWSmartGrid_getCurrentDevices',
						'XGWSmartGrid_getSmartStartDeviceLogs'
					);
	
	showPeriods($('#tableView tr'), x[0]);
	
	if (isManual) {
		showPeriods($('#working tr'), x[1]);
		showPeriods($('#nonworking tr'), x[2]);
		$('#workingRow').show();
		$('#nonworkingRow').show();
	} else {
		showPeriods($('#today tr'), x[1]);
		showPeriods($('#tomorrow tr'), x[2]);
		$('#todayRow').show();
		$('#tomorrowRow').show();
	}
	
	if(isError(x[3])) return;
	var devices = x[3].result; //remote.XGWSmartGrid_getCurrentDevices().result;
	if (devices && devices.length > 0) {
		var data = '<tbody>';
		for (i = 0; i < devices.length; i++) {
			var dev = devices[i];
			data += '<tr><td align="left" class="content"><span style="FONT-WEIGHT:bold;">' + dev.DeviceName + '</span> - ' + getTime(dev.StartTime) + 'h</td></tr>'
		}
		$('#activeDevices').html(data + '</tbody>');
	}

	if(isError(x[4])) return;
	devices = x[4].result; //remote.XGWSmartGrid_getSmartStartDeviceLogs().result;
	if (devices && devices.length > 0) {
		var data = '';
		for (i = 0; i < devices.length; i++){
			var dev = devices[i];
			data += '<tr><td align="left" class="content"><span style="FONT-WEIGHT:bold;">' + dev.DeviceName + '</span> - ' + dev.StartTime + 'h</td></tr>'
		}
		$('#deviceLog tbody').html(data);
	}

	$('#rootPane').show();
}

function getTime(minutes) {
	return checkTime(Math.floor(minutes / 60)) + ':' + checkTime(minutes % 60);
}

function showPeriods(component, x){
	if(isError(x)) return;
	aPeriods = x.result;

	if (aPeriods) {
		var p, width, color, s='';
		for(i = 0; i < aPeriods.length; i++){
			p = aPeriods[i];
			color = getColor(p.Tariff);
			width = getPixWidth(p.EndTime - p.BeginTime) - 2;
			s += '<td  valign="bottom" width="' + width + 'px ">' +
					'<div  class="borderRound aPeriod" style="cursor:default; background-color:'+ color +'; height:' + getHeight(p.Tariff) + 'px;"></div></td>'	
		}
		component.html(s);
	}
}

//////utility methods/////////

/*Round minutes to 15 minutes period*/
function roundMin(min){
	var m = min;
	var x = m % 15; 
	if(x != 0) m -= x;
	return m;
}

/*Return number of pixels corresponding to specified time period*/
function getPixWidth(min){
	return roundMin(min) / 15 * 9;
}
