var rpcURI = '/remote/json-rpc';
var remote = jQuery.JR(rpcURI);
var timer;

function resetMargins(details) {
	var size = 0;
	if (top.window.innerWidth) {
		size = top.window.innerWidth;
	} else {
		size = document.documentElement.clientWidth;
	}

	if (top.window.orientation) {
		if (top.window.orientation == 0 || top.window.orientation == 180) {
			if (top.window.innerHeight) {
				size = top.window.innerHeight;
			} else {
				size = document.documentElement.clientHeight;
			}
		}
	}
	//alert("orientation: " + top.window.orientation + ", width: " + top.window.innerWidth + ", height: " + top.window.innerHeight);
	if (size < 370) {
		return;
	}
	var check;
	if (details) {
		check = size - 330;
	} else {
		check = size % 340;
	}
	check = check / 2;
	var newMargins = '0 0 0 ' + check + 'px';

	var devList = top.frames[1].document.getElementById("deviceList");
	if (devList) {
		try {
			devList.style.margin=newMargins;

		} catch (error) {
		}
	}
}

function generateDeviceList() {
	var devices = remote.XGWAppliancesAdmin_getAppliances().result;
	var content = '';
	for (var i = 0; i < devices.length; i++) {
		var appClass = devices[i].ApplianceClass;
		var type = appClass.Value;
		var name = appClass.LocalizedValue;
		var state = devices[i].ApplianceState.LocalizedValue;
		var link = '';
		var addName = devices[i].AdditionalName;
		var keys = devices[i].ApplianceDescription;
		var devType = devices[i].ApplianceType;
		var devId = devices[i].ApplianceID;
		content += generateDeviceInfo(type, name, state, link, addName, keys, devType, devId);
	}
	$('#deviceList').html(content);
}

function startDeviceListMonitoring() {
    timer = setTimeout(timerFunction, 5000);
}

function timerFunction() {
	generateDeviceList();
    timer = setTimeout(timerFunction, 5000);
}

function generateTitle(value) {
	return '<div class="title">&nbsp;'+value+"</div>";
}

function generateLabel(value) {
	return '<div class="info">'+value+"</div>";
}

function generateIcon(type) {
	return '<div class="icon">' +
		   '  <img src="' + type + '.png" alt="device_icon" width="60" height="60" align="left" border="no"/>' +
		   "</div>";
}

function generateDeviceInfo(type, name, state, link, additionalName, keys, devType, devId) {
	var text = '<a class="device" title="Click for more info" href="info.html?type=' + devType+ '&' + 'id='+ devId + '">' + 
	generateIcon(type) +  
	generateTitle(additionalName && additionalName.length > 0 ? additionalName : name);
	text += generateLabel(state);
	
	var count = keys.length;
	for (var i = 0; i < count; i++) {
		if (keys[i].Filter) {
			var nameText = keys[i].LocalizedID;
			var valueText = keys[i].LocalizedValue;
			if (!valueText) valueText = "-";
			if (keys[i].ID == 'deviceState') {
				text += generateLabel(valueText);
			} else {
				text += generateLabel(nameText  + ': '+ valueText);
			}
		}
	}
	
	text += "</a>";
	return text;
}

var applianceId;
var applianceType;

function parseParams() {
	var search = location.search;

	if (search) {
		var input = search.substr(1);
		if (input) {
			var srchArray = input.split("&");
		    var results = new Array();
			var tempArray = new Array();
			for (var i = 0; i < srchArray.length; i++) {
				tempArray = srchArray[i].split("=");
				results[tempArray[0]] = tempArray[1];
				if (tempArray[0] == 'type') {
					applianceType = tempArray[1];
				} else if (tempArray[0] == 'id') {
					applianceId = tempArray[1];
				}
			}
		}
	}

	var deviceInfo = remote.XGWAppliancesAdmin_getApplianceTimestampDetailedInfo(applianceType, applianceId, 0).result;
	generateApplianceDetails(deviceInfo);
    infoTime = setTimeout(infoTimer, 5000);
}

var infoTime;

function infoTimer() {
	var deviceInfo = remote.XGWAppliancesAdmin_getApplianceTimestampDetailedInfo(applianceType, applianceId, lastTimeStamp).result;
	generateApplianceDetails(deviceInfo);
    infoTime = setTimeout(infoTimer, 5000);
}

var lastTimeStamp = 0;

function generateApplianceDetails(deviceInfo) {
	var appClass = deviceInfo.ApplianceClass;
	var type = appClass.Value;
	var name = appClass.LocalizedValue;
	var addName = deviceInfo.AdditionalName;
	var keys = deviceInfo.ApplianceDetails;
	var propsContent = '<table cellspacing="0" cellpadding="0" border="0" width="290px" style="padding: 0px 0px 10px 0px;"><tr><td valign="top" align="left" colspan="2"><table cellspacing="0" cellpadding="0" border="0"><tr><td valign="top" align="left">';
	propsContent += generateDetailsIcon(type) + '</td><td align="left" valign="top">';
	propsContent += generateDetailsTitle(addName && addName.length > 0 ? addName : name);
	propsContent += "</td></tr></table>";
	for (var i = 0; i < keys.length; i++) {
		if (keys[i].ID == 'LastModified') {
			if (lastTimeStamp == keys[i].Value) {
				// no changes 
				return;
			}
			lastTimeStamp = keys[i].Value;
			continue;
		} else if (keys[i].ID == 'mieleId') {
			continue;
		}
		if (keys[i].Filter) {
			propsContent += generateDeviceInfoLine(keys[i].LocalizedID, keys[i].LocalizedValue);
		}
	}
	propsContent += '</table>';
	var appType = deviceInfo.ApplianceType;
	var appID = deviceInfo.ApplianceID;
	var actionsContent = '';
	var added = false;
	var count = 0;
	var actions = deviceInfo.AvailableOperations;
	for (var i = 0; i < actions.length; i++) {
		if (actions[i].Filter) {
			if (!added) {
				added = true;
				actionsContent += '<table style="margin: 8px 0 0 0;" cellspacing="0" cellpadding="0" border="0" width="290px">';
			}
			var opID = actions[i].ID;
			var opName = actions[i].LocalizedID;
			if (count % 2 == 0) {
				actionsContent += '<tr>';
			}
			actionsContent += generateDeviceAction(opID, opName, appType, appID);
			if (count % 2 == 1) {
				actionsContent += '</tr>';
			}
			count++;
		}
	}
	if (count % 2 == 1) {
		actionsContent += "<td align='right' style='padding: 0px 0px 0px 14px;'><img style='height: 30px; width: 140px;' src='1x1.gif' /></td></tr>";	
	}

	if (added) {
		actionsContent += '</table>';
	}

	$('#deviceProps').html(propsContent);
	if (actionsContent.length > 0) {
		$('#deviceActions').html(actionsContent);
		$('#actionsTable').show();
	} else {
		$('#actionsTable').hide();
	}
}

function generateDetailsIcon(type) {
	return '<div class="devicon">' +
		   '  <img src="' + type + '.png" alt="device_icon" width="60" height="60" align="left" border="no"/>' +
		   '</div>';
}
function generateDetailsTitle(value) {
	return '<div class="devtitle">'+value+'</div>';
}
function generateDeviceInfoLine(name, value) {
	return '<tr class="prop">' + generatePropertyLabel(name, value) + "</tr>";
}

function generatePropertyLabel(name, value) {
	return '<td align="left" style="padding: 5px 0px 0px 8px;">' + name + '</td><td style="padding: 5px 0px 0px 0px;" align="left">'+value+'</td>';
}

function generateDeviceAction(operationId, name, type, id) {
    var text = "<td>";
	if (operationId.indexOf("start") > -1) {
	  text += '<a class="start" onclick="executeOperation(\'' + type + '\',\'' + id + '\',\'' + operationId + '\')">' + '<div style="padding: 2px 0px 0px 0px;">' + name + "</div></a>\n";
	} else if (operationId.indexOf("stop") > -1) {
	  text += '<a class="stop" onclick="executeOperation(\'' + type + '\',\'' + id + '\',\'' + operationId + '\')">' + '<div style="padding: 2px 0px 0px 0px;">' + name + "</div></a>\n";
	} else {
	  text += '<a class="action" onclick="executeOperation(\'' + type + '\',\'' + id + '\',\'' + operationId + '\')">' + '<div style="padding: 2px 0px 0px 0px;">' + name + "</div></a>\n";
	}
	
	return text + '</td>';
}

var resTypes = ['homebus.common'];
var okRes = ['info.label', 'action.ok'];
var errorRes = ['failure.label', 'action.error'];

function executeOperation(type, id, operationId) {
	var commandExec = remote.XGWAppliancesAdmin_executeOperation(type, id, operationId).result;
	var type;
	var title;
	var message;
	if (commandExec) {
		type = 'info';
		var resources = remote.XGWResource_getResources(resTypes, okRes).result;
		title = resources['info.label'];
		message = resources['action.ok'];
	} else {
		type = 'error';
		var resources = remote.XGWResource_getResources(resTypes, errorRes).result;
		title = resources['failure.label'];
		message = resources['action.error'];
	}
	showMessageDialog(type, title, message, actionCallback);
}

function actionCallback() {
	lastTimeStamp = 0;
	var deviceInfo = remote.XGWAppliancesAdmin_getApplianceTimestampDetailedInfo(applianceType, applianceId, lastTimeStamp).result;
	generateApplianceDetails(deviceInfo);
	closeMessageDialog();
}

function closeMessageDialog() {
  var contentLayer = $("#modalDialogPanel");
  var dialogPanel = $("#modalDialogPanel");
  var dialogFrame = $("#infoFrame");
  
  dialogPanel.hide();
  dialogFrame.hide();
  if (contentLayer && contentLayer != null) {
    contentLayer.hide();
  }
}

function showMessageDialog(type, title, message, callback) {
	var infoFrame = $("#infoFrame");
	var infoIcon = $("#messageIcon");
	var infoTitle = $("#messageTitle");
	var infoMessage = $("#messageText");
	infoIcon.html('  <img src="' + type + '.png" alt="device_icon" width="52" height="52" align="left" border="no"/>');
	infoTitle.html(title);
	infoMessage.html(message);
	
	var modalDialogPanel = $("#modalDialogPanel");
	modalDialogPanel.show();
	infoFrame.show();
	timer = setTimeout(callback, 5000);
}
